#pragma once

#include <string>
#include <map>

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̃}N`
////////////////////////////////////////////////////////////////////////

// bsfilter ̐ݒt@C
#define BSFILTER_CONFIG_FILENAME	"bsfilter.conf"

// bsfilter ̃f[^x[XtH_
#define BSFILTER_DB_FOLDERNAME		"bsfilterdb"

// BkBsfilWrapper ̐ݒt@C
#define CONFIG_FILENAME		"BkBsfilWrapper.ini"

// BkBsfilWrapper ̐ݒt@C(p)
#define CONFIG_ENV_FILENAME		"BkBsfilWrapperEnv.ini"

// zCgXg̃t@C
#define WHITELIST_FILENAME		"WhiteList.txt"

// NG [hꗗ̃t@C
#define NG_WORD_LIST_FILENAME	"NgWordList.txt"

// NG [hꗗ̃t@C
#define OK_WORD_LIST_FILENAME	"OkWordList.txt"

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̎
////////////////////////////////////////////////////////////////////////

// Oƃ[AhX𓾂
void GetDecodedNameAndAddr(char* name, int lenName, char* email, int lenEmail, const char* pSrc);

// wb_tB[hɑΉwb_tB[h{fBfR[hĕԂ
std::string GetDecodedHeaderFieldBody(const char* pSrc, const char* pHeaderFieldName);

// fR[hԂ
std::string GetDecodedString(std::string& str);

// M悩烁[AhẌꗗ𓾂
void AddSenderAddrToList(std::map<std::string, std::string>* pAddrList, std::string& to);

// bsfilter s
int ExecBsfilter(const char* pInput, int inputLength, std::string* pOutput, char* fmt, ...);

// Becky! ̃o[W`FbNs
bool IsValidBeckyVersion(const char* bkaVersion);

// s
bool Initialize();

// Is
void Release();

// spam Ɣ肳ꂽ[u
int ProcessSpamMail(LPCSTR lpMessage, LPCSTR lpMailBox, int* lpnAction, char** lppParam);

// spam  token f[^x[Xɑ
void WINAPI Menu_CmdProc_AddSpam(HWND hWnd, LPARAM lParam);

// clean ȃ[ token f[^x[Xɑ
void WINAPI Menu_CmdProc_AddClean(HWND hWnd, LPARAM lParam);

// spam  token f[^x[X
void WINAPI Menu_CmdProc_SubSpam(HWND hWnd, LPARAM lParam);

// clean ȃ[ token f[^x[X
void WINAPI Menu_CmdProc_SubClean(HWND hWnd, LPARAM lParam);

// mf[^x[XXV
void WINAPI Menu_CmdProc_Update(HWND hWnd, LPARAM lParam);

// f[^x[X̏Ԃ\
void WINAPI Menu_CmdProc_ShowDbStatus(HWND hWnd, LPARAM lParam);

// [ spam Ƃďu
void WINAPI Menu_CmdProc_ToSpam(HWND hWnd, LPARAM lParam);

// [ spam wb_
void WINAPI Menu_CmdProc_RemoveSpamHeader(HWND hWnd, LPARAM lParam);

// [𔻒肵U蕪
void WINAPI Menu_CmdProc_TestMailAndFilter(HWND hWnd, LPARAM lParam);

// [𔻒(eXg)
void WINAPI Menu_CmdProc_TestMail(HWND hWnd, LPARAM lParam);

// olzCgXgɒǉ
void WINAPI Menu_CmdProc_AddToWhiteList(HWND hWnd, LPARAM lParam);

// olhCzCgXgɒǉ
void WINAPI Menu_CmdProc_AddDomainToWhiteList(HWND hWnd, LPARAM lParam);

// olzCgXg폜
void WINAPI Menu_CmdProc_RemoveFromWhiteList(HWND hWnd, LPARAM lParam);

// olhCzCgXg폜
void WINAPI Menu_CmdProc_RemoveDomainFromWhiteList(HWND hWnd, LPARAM lParam);

// [̑IԂɂčڂ̕\E\ݒ肷
UINT WINAPI Menu_CmdUIProc(HWND hWnd, LPARAM lParam);

// ol NG [hɓo^
void WINAPI Menu_CmdProc_AddFromnameToNgWordList(HWND hWnd, LPARAM lParam);

//  NG [hɓo^
void WINAPI Menu_CmdProc_AddSubjectToNgWordList(HWND hWnd, LPARAM lParam);

// ol OK [hɓo^
void WINAPI Menu_CmdProc_AddFromnameToOkWordList(HWND hWnd, LPARAM lParam);

//  OK [hɓo^
void WINAPI Menu_CmdProc_AddSubjectToOkWordList(HWND hWnd, LPARAM lParam);

